

#variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1


    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable ShowLogFlag 0

    variable AcqCode 0
    variable AcqState 0
    variable AcqInfo "Unknown"

    variable AcqParameter "None"
    variable AcqSetOption "None"
    variable AcqGetOption "Null"

    variable JS ""


    source Global.tcl

    proc do_reset {} {
        global errorCode errorInfo
        variable AcqParameter

        set rc [catch {interp eval "" ::namespace inscope ::urn:DataAcquisitionControlServer do_DoReset "$AcqParameter"} m]
        if {$rc != 0} {
            InsertLog "RESET returned with an error\n$m\n$errorCode\n$errorInfo"
        } else {
#            InsertLog "RESET returned $m ([format "0x%x" $m])"
            InsertLog "RESET returned $m"
        }
        set rc [catch {interp eval "" ::namespace inscope ::urn:DataAcquisitionControlServer  do_ServerVerbose 0} m]
    }

    proc do_setup {} {
        global errorCode errorInfo
        variable AcqParameter

        set rc [catch {interp eval "" ::namespace inscope ::urn:DataAcquisitionControlServer do_DoSetUp "$AcqParameter"} m]
        if {$rc != 0} {
            InsertLog "SETUP returned with an error\n$m\n$errorCode\n$errorInfo"
        } else {
#            InsertLog "SETUP returned $m ([format "0x%x" $m])"
            InsertLog "SETUP returned $m"
        }
        set rc [catch {interp eval "" ::namespace inscope ::urn:DataAcquisitionControlServer  do_ServerVerbose 0} m]
    }

    proc do_stop {} {
        global errorCode errorInfo
        variable AcqParameter

        set rc [catch {interp eval "" ::namespace inscope ::urn:DataAcquisitionControlServer do_DoStop "$AcqParameter"} m]
        if {$rc != 0} {
            InsertLog "STOP returned with an error\n$m\n$errorCode\n$errorInfo"
        } else {
#            InsertLog "STOP returned $m ([format "0x%x" $m])"
            InsertLog "STOP returned $m"
        }
    }

    proc do_go {} {
        global errorCode errorInfo
        variable AcqParameter

        set rc [catch {interp eval "" ::namespace inscope ::urn:DataAcquisitionControlServer do_DoGo "$AcqParameter"} m]
        if {$rc != 0} {
            InsertLog "GO returned with an error\n$m\n$errorCode\n$errorInfo"
        } else {
#            InsertLog "GO returned $m ([format "0x%x" $m])"
            InsertLog "GO returned $m"
        }
    }

    proc do_setopt {} {
        global errorCode errorInfo
        variable AcqSetOption 

        set rc [catch {interp eval "" ::namespace inscope ::urn:DataAcquisitionControlServer do_DoOption $AcqSetOption} m]
        if {$rc != 0} {
            InsertLog "DO OPTION returned with an error\n$m\n$errorCode\n$errorInfo"
        } else {
#            InsertLog "DO OPTION returned $m ([format "0x%x" $m])"
            InsertLog "DO OPTION returned $m"
        }
    }

    proc do_getopt {} {
        global errorCode errorInfo
        variable AcqGetOption
        variable JS

        set rc [catch {interp eval "" ::namespace inscope ::urn:DataAcquisitionControlServer do_GetOption $AcqGetOption} m]
        if {$rc != 0} {
            InsertLog "GET OPTION returned with an error\n$m\n$errorCode\n$errorInfo"
        } else {
            set JS "alert(\"GetOption with parameter $AcqGetOption returned $m\");"
        }
    }

    proc do_state {} {
        global errorCode errorInfo
        variable AcqCode 
        variable AcqState
        variable AcqInfo 

        set rc [catch {interp eval "" ::namespace inscope ::urn:DataAcquisitionControlServer do_GetState} m]
        if {$rc != 0} {
            InsertLog "STATE returned with an error\n$m\n$errorCode\n$errorInfo"
        } else {
            set AcqCode [lindex $m 1]
            set AcqState [lindex $m 2]
            set AcqInfo [lindex $m 3]
            InsertLog "STATE returned $m"
        }
    }

    proc do_counters {} {
        global errorCode errorInfo

        set rc [catch {interp eval "" ::namespace inscope ::urn:DataAcquisitionControlServer do_GetCounters} m]
        if {$rc != 0} {
            InsertLog "COUNTERS returned with an error\n$m\n$errorCode\n$errorInfo"
        } else {
            InsertLog "COUNTERS returned $m"
        }
    }

    proc do_rates {} {
        global errorCode errorInfo

        set rc [catch {interp eval "" ::namespace inscope ::urn:DataAcquisitionControlServer do_GetRates} m]
        if {$rc != 0} {
            InsertLog "RATES returned with an error\n$m\n$errorCode\n$errorInfo"
        } else {
            InsertLog "RATES returned $m"
        }
    }


   proc  show_variables {} {
       variable ShowLogFlag
       variable JS
       variable AcqCode 
       variable AcqState
       variable AcqInfo
       variable AcqParameter
       variable AcqSetOption
       variable AcqGetOption

         if {$ShowLogFlag == 1} {
             EmptyLog
             InsertLog "AcqCode=$AcqCode; AcqState=$AcqState; AcqInfo=$AcqInfo"
             InsertLog "AcqParameter=$AcqParameter; AcqSetOption=$AcqSetOption; AcqGetOption=$AcqGetOption"
         }  else {
             append JS "alert(\"AcqCode=$AcqCode; AcqState=$AcqState; AcqInfo=$AcqInfo; AcqParameter=$AcqParameter; AcqSetOption=$AcqSetOption; AcqGetOption=$AcqGetOption"
             append JS "\");"
         }
   }

   proc do_parameters {} {
        variable cgidata
        variable AcqParameter 
        variable AcqSetOption 
        variable AcqGetOption

        for {set i 2} {$i < [llength $cgidata]} {incr i} {

            set name [lindex $cgidata $i]
            incr i
            set value [lindex $cgidata $i]

            switch -glob $name {

               Parameter  {
                    set AcqParameter $value
                    InsertLog "AcqParameter = $value"
               }
               SetOption  {
                    set AcqSetOption $value
                    InsertLog "AcqSetOption = $value"
               }
               GetOption  {
                    set AcqGetOption $value
                    InsertLog "AcqGetOption = $value"
               }
               default {}
            }
        }
   }

     proc do_click {} {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
           InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {
               set w [lindex $cgidata 1]

               do_parameters

               switch -glob $w {

                   RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   RELOAD   {}
                   VARIABLES {show_variables}

                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}

                   DORESET    {do_reset}
                   DOSETUP    {do_setup}
                   DOSTOP     {do_stop}
                   DOGO       {do_go}
                   UPDATESTATE -
                   DOSTATE    {}
                   DOCOUNTERS {do_counters}
                   DORATES    {do_rates}
                   DOSETOPT   {do_setopt}
                   DOGETOPT   {do_getopt}

                   MainLog {}
                   undefined {}
                   default {InsertLog "unexpected CGI data:  $cgidata"}
               }
           }
       }

       do_state
    }

}   ;# end of if {$started == 0}




